=== debian/changelog ===
glibc (2.5-2) unstable; urgency=low

  * Update Portuguese debconf translation, by Ricardo Silva.  Closes: #418301,
    #418472.
  * Update Brazilian Portuguese debconf translation, by Felipe Augusto van de
    Wiel.  Closes: #418332.
  * Update Romanian debconf translation, by Stan Ioan-Eugen.  Closes: #418337.
  * Update Turkish debconf translation, by Erçin Eker.  Closes: #418340.
  * Update Galician debconf translation, by Jacobo Tarrio.  Closes: #418365.
  * Update Arabic debconf translation, by Ossama Khayat.  Closes: #418378.
  * Update German debconf translation, by Helge Kreutzmann.  Closes: #418426.
  * Update Basque debconf translation, by Piarres Beobide.  Closes: #418521.
  * Update Swedish debconf translation, by Daniel Nylander.  Closes: #418545.
  * Update Spanish debconf translation, by Carlos Valdivia Yagüe.  Closes:
    #418720.
  * Update Russian debconf translation, by Yuri Kozlov.  Closes: #418748.
  * Update Czech debconf translation, by Miroslav Kure.  Closes: #418767.
  * debian/locales-depver: remove exp from the locales version.
  * Replace patches/alpha/submitted-sigsuspend.diff by
    patches/alpha/cvs-sigsuspend.diff from upstream.
  * patches/any/local-ldconfig-fsync.diff: call fsync() before closing
    /etc/ld.so.cache.  Closes: #416716.
  * Update Korean debconf translation, by Sunjae Park.  Closes: #418872.
  * patches/any/local-notls.diff: also include pthread.h from
    linuxthreads/sysdeps/pthread/gai_misc.h.
    m68k/cvs-m68k-update.diff: update from CVS.  Closes: #418881.
  * debian/local/usr_sbin/tzconfig: removed.
  * debian/local/manpages/tzconfig.8: removed.
  * debian/sysdeps/depflags.pl: conflict with tzdata (<< 2007e-2). Older
    versions need tzconfig.
  * patches/any/cvs-printf_fp-c.diff: update patch from CVS (fix exponent
    -4 special case handling when wcp == wstartp + 1).  Closes: #419225.

 -- Aurelien Jarno <aurel32@debian.org>  Sat, 14 Apr 2007 17:23:17 +0200

glibc (2.5-1) unstable; urgency=low

  * New upstream version 2.5.
    - Adds support of POSIX_MADV_* on mips, mipsel, arm and hppa.  Closes:
      #381294.
    - Fixes a pointer-to-long overflow in sunrpc code. Closes: #389084.
    - Fixes getent wrt ipv4 hosts lookups. Closes: #347358.
    - Fixes strtod wrt hex floats with negative exponent. Closes: #172562.
    - Fixes nice() errno when called without appropriate privileges.  Closes:
      #286825.
    - Provides sys/inotify.h. Closes: #369402.
    - Fixes strtod("INF") with some locales. Closes: #415417.

  [ Aurelien Jarno ]
  * debian/shlibver: Bump up to 2.5.
  * debian/copyright: update.
  * Remove locale/cvs-iso3166.diff (merged upstream).
  * Remove localedata/locale-ro_RO.diff (merged upstream).
  * Remove arm/cvs-portshead.patch (merged upstream).
  * Remove arm/local-dwarf2-buildfix.diff (merged upstream).
  * Remove hppa/cvs-clone.patch (merged upstream).
  * Remove hppa/cvs-portshead.diff (merged upstream).
  * Remove hppa/submitted-drop-utimes.diff (merged upstream).
  * Remove hurd-i386/cvs-machrules-make.diff (merged upstream).
  * Remove mips/cvs-fork.diff (merged upstream).
  * Remove mips/cvs-resource.diff (merged upstream).
  * Remove powerpc/cvs-procfs.diff (merged upstream).
  * Remove any/cvs-argp_h.diff (merged upstream).
  * Remove any/cvs-getcwd_c.diff (merged upstream).
  * Remove any/cvs-sysctl.diff (merged upstream).
  * Remove any/cvs-thread_signals.diff (merged upstream).
  * Remove any/cvs-uio_h.diff (merged upstream).
  * Remove any/cvs-sunrpc-xdrmem_setpos.diff (merged upstream).
  * Remove any/cvs-getent-wrong-struct-size.diff (merged upstream).
  * Remove any/submitted-strfmon.diff (merged upstream).
  * Remove all/submitted-uninitialized-byte-LC_CTYPE.diff (merged upstream).
  * Remove any/local-ttyname-devfs.diff (devfs is not supported anymore).
  * Update arm/local-no-hwcap.diff.
  * Update any/local-ldso-disable-hwcap.diff.
  * Update all/submitted-new-brf-encoding.diff.
  * debhelper.in/libc.docs: remove INTERFACE as it has been removed upstream.
  * sysdeps/depflags.pl: don't make libc6 depends on tzdata, as this package
    is of priority required. Should help to debconfize tzdata.
  * sysdeps/i386.mk: put the static Xen libc flavour in /usr/lib/xen.  Closes:
    #391372.
  * sysdeps/powerpc.mk: install 64-bit headers (actually gnu/stubs-64.h)
    directly into /usr/include and provide /usr/include/powerpc64-linux-gnu as
    a symlink to /usr/include for compatibility reasons.  Closes: #391858.
  * sysdeps/ppc64.mk: install 32-bit headers (actually gnu/stubs-32.h)
    directly into /usr/include and provide /usr/include/powerpc-linux-gnu as
    a symlink to /usr/include for compatibility reasons.
  * kfreebsd/local-scripts.diff: update.
  * kfreebsd/local-sys_queue_h.diff: update.
  * kfreebsd/local-sysdeps.diff: update to revision 1689 (from glibc-bsd).
  * kfreebsd/local-sysdeps-2.4.diff: remove.
  * sysdeps/kfreebsd: enable the ports add-on.
  * sysdeps/kfreebsd-i386.mk: ditto.
  * any/local-stubs_h.diff: new patch to fix a warning in stubs.h.  Closes:
    #394128.
  * alpha/submitted-sigsuspend.diff: new patch (fix the build on alpha) from
    the libc-alpha mailing list.
  * debian/local/manpages/*: fix typos.  Closes: #395427.
  * debian/debhelper.in/libc.dirs: don't provide /sys, now provided by
    initscripts.
  * debian/debhelper.in/nscd.init: add lsb header.
  * debian/rules.d/debhelper.mk: add support for installing lintian and linda
    overrides files.
  * debian/debhelper.in/libc.overrides: new file.
  * debian/debhelper.in/libc-dev.overrides: new file.
  * debian/debhelper.in/libc-alt.overrides: new file.
  * debian/debhelper.in/libc-otherbuild.overrides: new file.
  * debian/debhelper.in/libc-dev-otherbuild.overrides: new file.
  * debian/any/submitted-getcwd-sys_param_h.diff: new patch (fix the build
    with linuxthreads) from the libc-alpha mailing list.
  * debian/powerpc/cvs-tls-debug.diff: new patch (fix for debugging

