=== debian/control ===
Source: glibc
Section: libs
Priority: required
Build-Depends: gettext, make (>= 3.80-1), dpkg-dev (>= 1.13.5), bzip2, file,
 linux-kernel-headers [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
 mig (>= 1.3-2) [hurd-i386], hurd-dev (>= 20020608-1) [hurd-i386], gnumach-dev [hurd-i386],
 kfreebsd-kernel-headers [kfreebsd-i386 kfreebsd-amd64],
 gcc-4.0 [hurd-i386], gcc-4.1 [!hppa !hurd-i386], gcc-4.2 [hppa],
 autoconf, sed (>= 4.0.5-4), gawk, debhelper (>= 5.0),
 libc6-dev-amd64 [i386], libc6-dev-ppc64 [powerpc], libc6-dev-i386 [amd64], libc6-dev-powerpc [ppc64], libc6-dev-sparc64 [sparc], libc6-dev-s390x [s390], libc0.1-dev-i386 [kfreebsd-amd64], 
 lib32ssp0 [amd64 kfreebsd-amd64 ppc64], lib64ssp0 [i386 powerpc sparc s390],
 quilt
Build-Depends-Indep: perl, po-debconf (>= 1.0)
Build-Conflicts: gcc-4.1 (= 4.1.1-14)
Maintainer: GNU Libc Maintainers <debian-glibc@lists.debian.org>
Uploaders: Ben Collins <bcollins@debian.org>, GOTO Masanori <gotom@debian.org>, Philip Blundell <pb@nexus.co.uk>, Jeff Bailey <jbailey@raspberryginger.com>, Daniel Jacobowitz <dan@debian.org>, Clint Adams <schizo@debian.org>, Aurelien Jarno <aurel32@debian.org>, Pierre Habouzit <madcoder@debian.org>
Standards-Version: 3.7.2

Package: glibc-doc
Architecture: all
Section: doc
Priority: optional
Suggests: glibc-doc-reference
Description: GNU C Library: Documentation
 Contains man pages for libpthread functions and the complete GNU C Library
 ChangeLog.  The GNU C Library Reference manual has been moved into
 glibc-doc-reference for licensing reasons.

Package: locales
Architecture: all
Section: libs
Priority: standard
Depends: ${locale:Depends}, debconf | debconf-2.0
Conflicts: base-config, belocs-locales-bin, belocs-locales-data
Replaces: base-config, lliurex-belocs-locales-data
Description: GNU C Library: National Language (locale) data [support]
 Machine-readable data files, shared objects and programs used by the
 C library for localization (l10n) and internationalization (i18n) support.
 .
 This package contains the libc.mo i18n files, plus tools to generate
 locale definitions from source files (included in this package). It
 allows you to customize which definitions actually get
 generated. This is a space-saver over how this package used to be,
 with all locales generated by default. This created a package that
 unpacked to an excess of 30 megs.

Package: locales-all
Architecture: any
Section: libs
Priority: extra
Depends: ${locale:Depends}
Provides: locales
Description: GNU C Library: Precompiled locale data
 This package contains the precompiled locale data for all supported locales.
 A better alternative is to install the locales package and only select
 desired locales, but it can be useful on a low-memory machine because some
 locale files take a lot of memory to be compiled.

Package: nscd
Architecture: alpha amd64 arm arm-softfloat armeb armel i386 m32r m68k mips mipsel powerpc ppc64 sparc ia64 hppa s390 sh3 sh4 sh3eb sh4eb kfreebsd-i386 kfreebsd-amd64 
Section: admin
Priority: optional
Depends: ${shlibs:Depends}
Description: GNU C Library: Name Service Cache Daemon
 A daemon which handles passwd, group and host lookups
 for running programs and caches the results for the next
 query. You should install this package only if you use
 slow Services like LDAP, NIS or NIS+

Package: libc6
Architecture: amd64 arm arm-softfloat armeb armel i386 m32r m68k mips mipsel powerpc ppc64 sparc s390 hppa sh3 sh4 sh3eb sh4eb
Section: libs
Priority: required
Provides: ${locale-compat:Depends}
Description: GNU C Library: Shared libraries
 Contains the standard libraries that are used by nearly all programs on
 the system. This package includes shared versions of the standard C library
 and the standard math library, as well as many others.

Package: libc6-dev
Architecture: amd64 arm arm-softfloat armeb armel i386 m32r m68k mips mipsel powerpc ppc64 sparc s390 hppa sh3 sh4 sh3eb sh4eb
Section: libdevel
Priority: optional
Depends: libc6 (= ${Source-Version})
Recommends: gcc | c-compiler
Description: GNU C Library: Development Libraries and Header Files
 Contains the symlinks, headers, and object files needed to compile
 and link programs which use the standard C library.

Package: libc6-dbg
Architecture: amd64 arm arm-softfloat armeb armel i386 m32r m68k mips mipsel powerpc ppc64 sparc s390 hppa sh3 sh4 sh3eb sh4eb
Section: libdevel
Priority: extra
Provides: libc-dbg
Depends: libc6 (= ${Source-Version})
Description: GNU C Library: Libraries with debugging symbols
 Contains unstripped shared libraries.
 This package is provided primarily to provide a backtrace with
 names in a debugger, which makes it somewhat easier to interpret core
 dumps. The libraries are installed in /usr/lib/debug and can be
 used by placing that directory in LD_LIBRARY_PATH.
 Most people will not need this package.

Package: libc6-prof
Architecture: amd64 arm arm-softfloat armeb armel i386 m32r m68k mips mipsel powerpc ppc64 sparc s390 hppa sh3 sh4 sh3eb sh4eb
Section: libdevel
Priority: extra
Depends: libc6 (= ${Source-Version})
Description: GNU C Library: Profiling Libraries
 Static libraries compiled with profiling info (-pg) suitable for use
 with gprof.

Package: libc6-pic
Architecture: amd64 arm arm-softfloat armeb armel i386 m32r m68k mips mipsel powerpc ppc64 sparc s390 hppa sh3 sh4 sh3eb sh4eb
Section: libdevel
Priority: optional
Conflicts: libc-pic
Provides: libc-pic, glibc-pic
Depends: libc6 (= ${Source-Version})
Description: GNU C Library: PIC archive library
 Contains an archive library (ar file) composed of individual shared objects.
 This is used for creating a library which is a smaller subset of the
 standard libc shared library. The reduced library is used on the Debian
 boot floppies. If you are not making your own set of Debian boot floppies
 using the `boot-floppies' package, you probably don't need this package.

Package: libc6-udeb
XC-Package-Type: udeb
Architecture: amd64 arm arm-softfloat armeb armel i386 m32r m68k mips mipsel powerpc ppc64 sparc s390 hppa sh3 sh4 sh3eb sh4eb
Section: debian-installer
Priority: extra
Provides: libc6, libc-udeb, ${locale-compat:Depends}
Description: GNU C Library: Shared libraries - udeb
 Contains the standard libraries that are used by nearly all programs on
 the system. This package includes shared versions of the standard C library
 and the standard math library, as well as many others.
 .
 This package contains a minimal set of libraries needed for the Debian
 installer.  Do not install it on a normal system.

Package: libc6.1
Architecture: alpha ia64
Section: libs
Priority: required
Provides: ${locale-compat:Depends}
Description: GNU C Library: Shared libraries
 Contains the standard libraries that are used by nearly all programs on
 the system. This package includes shared versions of the standard C library
 and the standard math library, as well as many others.

Package: libc6.1-dev
Architecture: alpha ia64
Section: libdevel
Priority: optional
Depends: libc6.1 (= ${Source-Version})
Recommends: gcc | c-compiler
Description: GNU C Library: Development Libraries and Header Files
 Contains the symlinks, headers, and object files needed to compile
 and link programs which use the standard C library.

Package: libc6.1-dbg
Architecture: alpha ia64
Section: libdevel
Priority: extra
Provides: libc-dbg
Depends: libc6.1 (= ${Source-Version})
Description: GNU C Library: Libraries with debugging symbols
 Contains unstripped shared libraries.
 This package is provided primarily to provide a backtrace with
 names in a debugger, which makes it somewhat easier to interpret core
 dumps. The libraries are installed in /usr/lib/debug and can be
 used by placing that directory in LD_LIBRARY_PATH.
 Most people will not need this package.

Package: libc6.1-prof
Architecture: alpha ia64
Section: libdevel
Priority: extra
Depends: libc6.1 (= ${Source-Version})
Description: GNU C Library: Profiling Libraries
 Static libraries compiled with profiling info (-pg) suitable for use
 with gprof.

Package: libc6.1-pic
Architecture: alpha ia64
Section: libdevel
Priority: optional
Conflicts: libc-pic
Provides: libc-pic, glibc-pic
Depends: libc6.1 (= ${Source-Version})
Description: GNU C Library: PIC archive library
 Contains an archive library (ar file) composed of individual shared objects.
 This is used for creating a library which is a smaller subset of the
 standard libc shared library. The reduced library is used on the Debian
 boot floppies. If you are not making your own set of Debian boot floppies
 using the `boot-floppies' package, you probably don't need this package.

Package: libc6.1-udeb
XC-Package-Type: udeb
Architecture: alpha ia64
Section: debian-installer
Priority: extra
Provides: libc6.1, libc-udeb, ${locale-compat:Depends}
Description: GNU C Library: Shared libraries - udeb
 Contains the standard libraries that are used by nearly all programs on
 the system. This package includes shared versions of the standard C library
 and the standard math library, as well as many others.
 .
 This package contains a minimal set of libraries needed for the Debian
 installer.  Do not install it on a normal system.

Package: libc0.3
Architecture: hurd-i386
Section: libs
Priority: required
Provides: ${locale-compat:Depends}
Description: GNU C Library: Shared libraries
 Contains the standard libraries that are used by nearly all programs on
 the system. This package includes shared versions of the standard C library
 and the standard math library, as well as many others.

Package: libc0.3-dev
Architecture: hurd-i386
Section: libdevel
Priority: optional
Depends: libc0.3 (= ${Source-Version})
Recommends: gcc | c-compiler
Description: GNU C Library: Development Libraries and Header Files
 Contains the symlinks, headers, and object files needed to compile
 and link programs which use the standard C library.

Package: libc0.3-dbg
Architecture: hurd-i386
Section: libdevel
Priority: extra
Provides: libc-dbg
Depends: libc0.3 (= ${Source-Version})
Description: GNU C Library: Libraries with debugging symbols
 Contains unstripped shared libraries.
 This package is provided primarily to provide a backtrace with
 names in a debugger, which makes it somewhat easier to interpret core
 dumps. The libraries are installed in /usr/lib/debug and can be
 used by placing that directory in LD_LIBRARY_PATH.
 Most people will not need this package.

Package: libc0.3-prof
Architecture: hurd-i386
Section: libdevel
Priority: extra
Depends: libc0.3 (= ${Source-Version})
Description: GNU C Library: Profiling Libraries
 Static libraries compiled with profiling info (-pg) suitable for use
 with gprof.

Package: libc0.3-pic
Architecture: hurd-i386
Section: libdevel
Priority: optional
Conflicts: libc-pic
Provides: libc-pic, glibc-pic
Depends: libc0.3 (= ${Source-Version})
Description: GNU C Library: PIC archive library
 Contains an archive library (ar file) composed of individual shared objects.
 This is used for creating a library which is a smaller subset of the
 standard libc shared library. The reduced library is used on the Debian
 boot floppies. If you are not making your own set of Debian boot floppies
 using the `boot-floppies' package, you probably don't need this package.

Package: libc0.3-udeb
XC-Package-Type: udeb
Architecture: hurd-i386
Section: debian-installer
Priority: extra
Provides: libc0.3, libc-udeb, ${locale-compat:Depends}
Description: GNU C Library: Shared libraries - udeb
 Contains the standard libraries that are used by nearly all programs on
 the system. This package includes shared versions of the standard C library
 and the standard math library, as well as many others.
 .
 This package contains a minimal set of libraries needed for the Debian
 installer.  Do not install it on a normal system.

Package: libc0.1
Architecture: kfreebsd-i386 kfreebsd-amd64
Section: libs
Priority: required
Provides: ${locale-compat:Depends}
Description: GNU C Library: Shared libraries
